diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/Makefile.org openssl-1.0.1f-rlwekex/Makefile.org
--- openssl-1.0.1f/Makefile.org	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/Makefile.org	2014-10-16 12:38:15.000000000 +0200
@@ -142,11 +142,11 @@
 # dirs in crypto to build
 SDIRS=  \
 	objects \
 	md2 md4 md5 sha mdc2 hmac ripemd whrlpool \
 	des aes rc2 rc4 rc5 idea bf cast camellia seed modes \
-	bn ec rsa dsa ecdsa dh ecdh dso engine \
+	bn ec rsa dsa ecdsa dh ecdh rlwekex dso engine \
 	buffer bio stack lhash rand err \
 	evp asn1 pem x509 x509v3 conf txt_db pkcs7 pkcs12 comp ocsp ui krb5 \
 	cms pqueue ts jpake srp store cmac
 # keep in mind that the above list is adjusted by ./Configure
 # according to no-xxx arguments...
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/apps/speed.c openssl-1.0.1f-rlwekex/apps/speed.c
--- openssl-1.0.1f/apps/speed.c	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/apps/speed.c	2014-10-16 12:51:57.000000000 +0200
@@ -77,10 +77,11 @@
 #define SECONDS		3	
 #define RSA_SECONDS	10
 #define DSA_SECONDS	10
 #define ECDSA_SECONDS   10
 #define ECDH_SECONDS    10
+#define RLWEKEX_SECONDS    10
 
 /* 11-Sep-92 Andrew Daviel   Support for Silicon Graphics IRIX added */
 /* 06-Apr-92 Luke Brennan    Support for VMS and add extra signal calls */
 
 #undef PROG
@@ -187,10 +188,13 @@
 #include <openssl/ecdsa.h>
 #endif
 #ifndef OPENSSL_NO_ECDH
 #include <openssl/ecdh.h>
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+#include <openssl/rlwekex.h>
+#endif
 #include <openssl/modes.h>
 
 #ifdef OPENSSL_FIPS
 #ifdef OPENSSL_DOING_MAKEDEPEND
 #undef AES_set_encrypt_key
@@ -245,10 +249,13 @@
 #define DSA_NUM		3
 
 #define EC_NUM       16
 #define MAX_ECDH_SIZE 256
 
+#define RLWEKEX_NUM	1
+#define MAX_RLWEKEX_SIZE 256
+
 static const char *names[ALGOR_NUM]={
   "md2","mdc2","md4","md5","hmac(md5)","sha1","rmd160","rc4",
   "des cbc","des ede3","idea cbc","seed cbc",
   "rc2 cbc","rc5-32/12 cbc","blowfish cbc","cast cbc",
   "aes-128 cbc","aes-192 cbc","aes-256 cbc",
@@ -267,10 +274,13 @@
 static double ecdsa_results[EC_NUM][2];
 #endif
 #ifndef OPENSSL_NO_ECDH
 static double ecdh_results[EC_NUM][1];
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+static double rlwekex_results[RLWEKEX_NUM][3];
+#endif
 
 #if defined(OPENSSL_NO_DSA) && !(defined(OPENSSL_NO_ECDSA) && defined(OPENSSL_NO_ECDH))
 static const char rnd_seed[] = "string to make the random number generator think it has entropy";
 static int rnd_fake = 0;
 #endif
@@ -339,11 +349,12 @@
 	return app_tminterval(s,usertime);
 	}
 #endif
 
 
-#ifndef OPENSSL_NO_ECDH
+#if defined(OPENSSL_NO_ECDH) && defined(OPENSSL_NO_RLWEKEX)
+#else
 static const int KDF1_SHA1_len = 20;
 static void *KDF1_SHA1(const void *in, size_t inlen, void *out, size_t *outlen)
 	{
 #ifndef OPENSSL_NO_SHA
 	if (*outlen < SHA_DIGEST_LENGTH)
@@ -353,11 +364,11 @@
 	return SHA1(in, inlen, out);
 #else
 	return NULL;
 #endif	/* OPENSSL_NO_SHA */
 	}
-#endif	/* OPENSSL_NO_ECDH */
+#endif	/* defined(OPENSSL_NO_ECDH) || defined(OPENSSL_NO_RLWEKEX) */
 
 
 int MAIN(int, char **);
 
 int MAIN(int argc, char **argv)
@@ -611,18 +622,30 @@
 	int ecdh_checks = 0;
 	int secret_idx = 0;
 	long ecdh_c[EC_NUM][2];
 #endif
 
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PAIR *rlwekex_a[RLWEKEX_NUM], *rlwekex_b[RLWEKEX_NUM];
+	RLWE_REC *rlwekex_rec[RLWEKEX_NUM];
+	RLWE_CTX *rlwekex_ctx;
+	unsigned char rlwekex_secret_a[MAX_RLWEKEX_SIZE], rlwekex_secret_b[MAX_RLWEKEX_SIZE];
+	int rlwekex_secret_size_a, rlwekex_secret_size_b;
+	long rlwekex_c[RLWEKEX_NUM][3];
+#endif
+
 	int rsa_doit[RSA_NUM];
 	int dsa_doit[DSA_NUM];
 #ifndef OPENSSL_NO_ECDSA
 	int ecdsa_doit[EC_NUM];
 #endif
 #ifndef OPENSSL_NO_ECDH
         int ecdh_doit[EC_NUM];
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+        int rlwekex_doit[RLWEKEX_NUM];
+#endif
 	int doit[ALGOR_NUM];
 	int pr_header=0;
 	const EVP_CIPHER *evp_cipher=NULL;
 	const EVP_MD *evp_md=NULL;
 	int decrypt=0;
@@ -647,10 +670,19 @@
 		{
 		ecdh_a[i] = NULL;
 		ecdh_b[i] = NULL;
 		}
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	rlwekex_ctx = NULL;
+	for (i=0; i<RLWEKEX_NUM; i++)
+		{
+		rlwekex_a[i] = NULL;
+		rlwekex_b[i] = NULL;
+		rlwekex_rec[i] = NULL;
+		}
+#endif
 
 
 	if (bio_err == NULL)
 		if ((bio_err=BIO_new(BIO_s_file())) != NULL)
 			BIO_set_fp(bio_err,stderr,BIO_NOCLOSE|BIO_FP_TEXT);
@@ -691,10 +723,14 @@
 #endif
 #ifndef OPENSSL_NO_ECDH
 	for (i=0; i<EC_NUM; i++)
 		ecdh_doit[i]=0;
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	for (i=0; i<RLWEKEX_NUM; i++)
+		rlwekex_doit[i]=0;
+#endif
 
 	
 	j=0;
 	argc--;
 	argv++;
@@ -1003,10 +1039,18 @@
 			for (i=0; i < EC_NUM; i++)
 				ecdh_doit[i]=1;
 			}
 		else
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+		     if (strcmp(*argv,"rlwekex") == 0)
+			{
+			for (i=0; i < RLWEKEX_NUM; i++)
+				rlwekex_doit[i]=1;
+			}
+		else
+#endif
 			{
 			BIO_printf(bio_err,"Error: bad option or value\n");
 			BIO_printf(bio_err,"\n");
 			BIO_printf(bio_err,"Available values:\n");
 #ifndef OPENSSL_NO_MD2
@@ -1098,10 +1142,13 @@
 			BIO_printf(bio_err,"ecdhp160  ecdhp192  ecdhp224  ecdhp256  ecdhp384  ecdhp521\n");
 			BIO_printf(bio_err,"ecdhk163  ecdhk233  ecdhk283  ecdhk409  ecdhk571\n");
 			BIO_printf(bio_err,"ecdhb163  ecdhb233  ecdhb283  ecdhb409  ecdhb571\n");
 			BIO_printf(bio_err,"ecdh\n");
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+			BIO_printf(bio_err,"rlwekex\n");
+#endif
 
 #ifndef OPENSSL_NO_IDEA
 			BIO_printf(bio_err,"idea     ");
 #endif
 #ifndef OPENSSL_NO_SEED
@@ -1175,10 +1222,14 @@
 #endif
 #ifndef OPENSSL_NO_ECDH
 		for (i=0; i<EC_NUM; i++)
 			ecdh_doit[i]=1;
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+		for (i=0; i<RLWEKEX_NUM; i++)
+			rlwekex_doit[i]=1;
+#endif
 		}
 	for (i=0; i<ALGOR_NUM; i++)
 		if (doit[i]) pr_header++;
 
 	if (usertime == 0 && !mr)
@@ -1482,10 +1533,16 @@
 				ecdh_c[i][1]=1;
 				}
 			}
 		}
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	for (i=0; i<=RLWEKEX_NUM; i++) {
+		rlwekex_c[i][0]=count/1000;
+		rlwekex_c[i][1]=count/1000;
+	}
+#endif
 
 #define COND(d)	(count < (d))
 #define COUNT(d) (d)
 #else
 /* not worth fixing */
@@ -2387,10 +2444,109 @@
 			ecdh_doit[j]=0;
 			}
 		}
 	if (rnd_fake) RAND_cleanup();
 #endif
+
+#ifndef OPENSSL_NO_RWLEKEX
+	if (RAND_status() != 1)
+		{
+		RAND_seed(rnd_seed, sizeof rnd_seed);
+		rnd_fake = 1;
+		}
+	rlwekex_ctx = RLWE_CTX_new();
+	if (rlwekex_ctx == NULL)
+		{
+		BIO_printf(bio_err,"RLWEKEX failure.\n");
+		ERR_print_errors(bio_err);
+		rsa_count=1;
+		}
+	else 
+		{
+		for (j=0; j<RLWEKEX_NUM; j++)
+			{
+			if (!rlwekex_doit[j]) continue;
+			rlwekex_a[j] = RLWE_PAIR_new();
+			rlwekex_b[j] = RLWE_PAIR_new();
+			rlwekex_rec[j] = RLWE_REC_new();
+			if ((rlwekex_a[j] == NULL) || (rlwekex_b[j] == NULL) || (rlwekex_rec[j] == NULL))
+				{
+				BIO_printf(bio_err,"RLWEKEX failure.\n");
+				ERR_print_errors(bio_err);
+				rsa_count=1;
+				}
+			else
+				{
+
+				/* Time RLWEKEX key generation */
+				pkey_print_message("rlwe","key generation", rlwekex_c[j][0], 1024, RLWEKEX_SECONDS);
+				Time_F(START);
+				for (count=0,run=1; COND(rlwekex_c[j][0]); count++)
+					{
+					RLWE_PAIR_generate_key(rlwekex_a[j], rlwekex_ctx);
+					}
+				d=Time_F(STOP);
+				BIO_printf(bio_err, mr ? "+R9:%ld:%d:%.2f\n" :"%ld n=%d RLWE key generations in %.2fs\n",
+					count, 1024, d);
+				rlwekex_results[j][0]=d/(double)count;
+				rsa_count=count;
+
+				rlwekex_secret_size_b = KDF1_SHA1_len;
+				rlwekex_secret_size_a = KDF1_SHA1_len;
+				/* generate two RLWE key pairs */
+				if (!RLWE_PAIR_generate_key(rlwekex_a[j], rlwekex_ctx) ||
+					!RLWE_PAIR_generate_key(rlwekex_b[j], rlwekex_ctx))
+					{
+					BIO_printf(bio_err,"RLWEKEX key generation failure.\n");
+					ERR_print_errors(bio_err);
+					rsa_count=1;		
+					}
+				else
+					{
+					/* Time RLWEKEX Bob shared secret generation */
+					pkey_print_message("rlwe","Bob shared secret", rlwekex_c[j][1], 1024, RLWEKEX_SECONDS);
+					Time_F(START);
+					for (count=0,run=1; COND(rlwekex_c[j][1]); count++)
+						{
+						RLWEKEX_compute_key_bob(rlwekex_secret_b, rlwekex_secret_size_b, rlwekex_rec[j], 
+							RLWE_PAIR_get_publickey(rlwekex_a[j]), rlwekex_b[j], KDF1_SHA1, rlwekex_ctx);
+						}
+					d=Time_F(STOP);
+					BIO_printf(bio_err, mr ? "+R10:%ld:%d:%.2f\n" :"%ld n=%d RLWE Bob shared secret in %.2fs\n",
+						count, 1024, d);
+					rlwekex_results[j][1]=d/(double)count;
+					rsa_count=count;
+
+					/* Time RLWEKEX Alice shared secret generation */
+					pkey_print_message("rlwe","Alice shared secret", rlwekex_c[j][2], 1024, RLWEKEX_SECONDS);
+					Time_F(START);
+					for (count=0,run=1; COND(rlwekex_c[j][2]); count++)
+						{
+						RLWEKEX_compute_key_alice(rlwekex_secret_a, rlwekex_secret_size_a, 
+							RLWE_PAIR_get_publickey(rlwekex_b[j]), rlwekex_rec[j], rlwekex_a[j], KDF1_SHA1, rlwekex_ctx);
+						}
+					d=Time_F(STOP);
+					BIO_printf(bio_err, mr ? "+R11:%ld:%d:%.2f\n" :"%ld n=%d RLWE Alice shared secret in %.2fs\n",
+						count, 1024, d);
+					rlwekex_results[j][2]=d/(double)count;
+					rsa_count=count;
+
+					}
+				}
+
+			if (rsa_count <= 1)
+				{
+				/* if longer than 10s, don't do any more */
+				for (j++; j<RLWEKEX_NUM; j++)
+					rlwekex_doit[j]=0;
+				}
+			}
+
+		}
+	if (rnd_fake) RAND_cleanup();
+#endif
+
 #ifndef NO_FORK
 show_res:
 #endif
 	if(!mr)
 		{
@@ -2535,10 +2691,34 @@
 				test_curves_names[k],
 				ecdh_results[k][0], 1.0/ecdh_results[k][0]);
 		}
 #endif
 
+#ifndef OPENSSL_NO_RLWEKEX
+	j=1;
+	for (k=0; k<RLWEKEX_NUM; k++)
+		{
+		if (!rlwekex_doit[k]) continue;
+		if (j && !mr)
+			{
+			printf("%19skeygen   keygen/s   Bob shared      Bob/s   Alice shared    Alice/s\n"," ");
+			j=0;
+			}
+		if (mr)
+			fprintf(stdout,"+F6:%u:%u:%f:%f:%f\n",
+				k, 1024,
+				rlwekex_results[k][0], rlwekex_results[k][1], rlwekex_results[k][2]);
+
+		else
+			fprintf(stdout,"rlwe n=%4u     %8.4fs    %8.1f   %8.4fs   %8.1f      %8.4fs   %8.1f\n",
+				1024,
+				rlwekex_results[k][0], 1.0/rlwekex_results[k][0],
+				rlwekex_results[k][1], 1.0/rlwekex_results[k][1],
+				rlwekex_results[k][2], 1.0/rlwekex_results[k][2]);
+		}
+#endif
+
 	mret=0;
 
 end:
 	ERR_print_errors(bio_err);
 	if (buf != NULL) OPENSSL_free(buf);
@@ -2566,10 +2746,21 @@
 			EC_KEY_free(ecdh_a[i]);
 		if (ecdh_b[i] != NULL)
 			EC_KEY_free(ecdh_b[i]);
 	}
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	for (i=0; i<RLWEKEX_NUM; i++)
+	{
+		if (rlwekex_a[i] != NULL)
+			RLWE_PAIR_free(rlwekex_a[i]);
+		if (rlwekex_b[i] != NULL)
+			RLWE_PAIR_free(rlwekex_b[i]);
+		if (rlwekex_rec[i] != NULL)
+			RLWE_REC_free(rlwekex_rec[i]);
+	}
+#endif
 
 	apps_shutdown();
 	OPENSSL_EXIT(mret);
 	}
 
@@ -2824,10 +3015,29 @@
 					ecdh_results[k][0]=d;
 
 				}
 #endif
 
+#ifndef OPENSSL_NO_RLWEKEX
+			else if(!strncmp(buf,"+F6:",4))
+				{
+				int k;
+				double d;
+				
+				p=buf+4;
+				k=atoi(sstrsep(&p,sep));
+				sstrsep(&p,sep);
+
+				d=atof(sstrsep(&p,sep));
+				if(n)
+					rlwekex_results[k][0]=1/(1/rlwekex_results[k][0]+1/d);
+				else
+					rlwekex_results[k][0]=d;
+
+				}
+#endif
+
 			else if(!strncmp(buf,"+H:",3))
 				{
 				}
 			else
 				fprintf(stderr,"Unknown type '%s' from child %d\n",buf,n);
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/err/err.h openssl-1.0.1f-rlwekex/crypto/err/err.h
--- openssl-1.0.1f/crypto/err/err.h	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/err/err.h	2014-10-16 12:38:19.000000000 +0200
@@ -190,10 +190,11 @@
 #define ERR_LIB_OCSP            39
 #define ERR_LIB_UI              40
 #define ERR_LIB_COMP            41
 #define ERR_LIB_ECDSA		42
 #define ERR_LIB_ECDH		43
+#define ERR_LIB_RLWEKEX		50
 #define ERR_LIB_STORE           44
 #define ERR_LIB_FIPS		45
 #define ERR_LIB_CMS		46
 #define ERR_LIB_TS		47
 #define ERR_LIB_HMAC		48
@@ -226,10 +227,11 @@
 #define OCSPerr(f,r) ERR_PUT_error(ERR_LIB_OCSP,(f),(r),__FILE__,__LINE__)
 #define UIerr(f,r) ERR_PUT_error(ERR_LIB_UI,(f),(r),__FILE__,__LINE__)
 #define COMPerr(f,r) ERR_PUT_error(ERR_LIB_COMP,(f),(r),__FILE__,__LINE__)
 #define ECDSAerr(f,r)  ERR_PUT_error(ERR_LIB_ECDSA,(f),(r),__FILE__,__LINE__)
 #define ECDHerr(f,r)  ERR_PUT_error(ERR_LIB_ECDH,(f),(r),__FILE__,__LINE__)
+#define RLWEKEXerr(f,r)  ERR_PUT_error(ERR_LIB_RLWEKEX,(f),(r),__FILE__,__LINE__)
 #define STOREerr(f,r) ERR_PUT_error(ERR_LIB_STORE,(f),(r),__FILE__,__LINE__)
 #define FIPSerr(f,r) ERR_PUT_error(ERR_LIB_FIPS,(f),(r),__FILE__,__LINE__)
 #define CMSerr(f,r) ERR_PUT_error(ERR_LIB_CMS,(f),(r),__FILE__,__LINE__)
 #define TSerr(f,r) ERR_PUT_error(ERR_LIB_TS,(f),(r),__FILE__,__LINE__)
 #define HMACerr(f,r) ERR_PUT_error(ERR_LIB_HMAC,(f),(r),__FILE__,__LINE__)
@@ -288,10 +290,11 @@
 #define ERR_R_COMP_LIB	ERR_LIB_COMP     /* 41 */
 #define ERR_R_ECDSA_LIB ERR_LIB_ECDSA	 /* 42 */
 #define ERR_R_ECDH_LIB  ERR_LIB_ECDH	 /* 43 */
 #define ERR_R_STORE_LIB ERR_LIB_STORE    /* 44 */
 #define ERR_R_TS_LIB	ERR_LIB_TS       /* 45 */
+#define ERR_R_RLWE_LIB  ERR_LIB_RLWEKEX	 /* 46 */
 
 #define ERR_R_NESTED_ASN1_ERROR			58
 #define ERR_R_BAD_ASN1_OBJECT_HEADER		59
 #define ERR_R_BAD_GET_ASN1_OBJECT_CALL		60
 #define ERR_R_EXPECTING_AN_ASN1_SEQUENCE	61
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/err/openssl.ec openssl-1.0.1f-rlwekex/crypto/err/openssl.ec
--- openssl-1.0.1f/crypto/err/openssl.ec	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/err/openssl.ec	2014-10-16 12:38:19.000000000 +0200
@@ -28,10 +28,11 @@
 L OCSP		crypto/ocsp/ocsp.h		crypto/ocsp/ocsp_err.c
 L UI		crypto/ui/ui.h			crypto/ui/ui_err.c
 L COMP		crypto/comp/comp.h		crypto/comp/comp_err.c
 L ECDSA		crypto/ecdsa/ecdsa.h		crypto/ecdsa/ecs_err.c
 L ECDH		crypto/ecdh/ecdh.h		crypto/ecdh/ech_err.c
+L RLWEKEX	crypto/rlwekex/rlwekex.h		crypto/rlwekex/rlwekex_err.c
 L STORE		crypto/store/store.h		crypto/store/str_err.c
 L TS		crypto/ts/ts.h			crypto/ts/ts_err.c
 L HMAC		crypto/hmac/hmac.h		crypto/hmac/hmac_err.c
 L CMS		crypto/cms/cms.h		crypto/cms/cms_err.c
 L JPAKE		crypto/jpake/jpake.h		crypto/jpake/jpake_err.c
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/Makefile openssl-1.0.1f-rlwekex/crypto/rlwekex/Makefile
--- openssl-1.0.1f/crypto/rlwekex/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/Makefile	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,96 @@
+#
+# crypto/rlwekex/Makefile
+#
+
+DIR=	rlwekex
+TOP=	../..
+CC=	cc
+INCLUDES= -I.. -I$(TOP) -I../../include
+CFLAG=-g -Wall
+MAKEFILE=	Makefile
+AR=		ar r
+
+CFLAGS= $(INCLUDES) $(CFLAG)
+
+GENERAL=Makefile
+TEST=rlwekextest.c
+APPS=
+
+LIB=$(TOP)/libcrypto.a
+LIBSRC=	rlwekex_key.c rlwekex_err.c
+
+LIBOBJ=	rlwekex_key.o rlwekex_err.o
+
+SRC= $(LIBSRC)
+
+EXHEADER= rlwekex.h
+HEADER=	rlwekex_locl.h $(EXHEADER)
+
+ALL=    $(GENERAL) $(SRC) $(HEADER)
+
+top:
+	(cd ../..; $(MAKE) DIRS=crypto SDIRS=$(DIR) sub_all)
+
+all:	lib
+
+lib:	$(LIBOBJ)
+	$(AR) $(LIB) $(LIBOBJ)
+	$(RANLIB) $(LIB) || echo Never mind.
+	@touch lib
+
+files:
+	$(PERL) $(TOP)/util/files.pl Makefile >> $(TOP)/MINFO
+
+links:
+	@$(PERL) $(TOP)/util/mklink.pl ../../include/openssl $(EXHEADER)
+	@$(PERL) $(TOP)/util/mklink.pl ../../test $(TEST)
+	@$(PERL) $(TOP)/util/mklink.pl ../../apps $(APPS)
+
+install:
+	@[ -n "$(INSTALLTOP)" ] # should be set by top Makefile...
+	@headerlist="$(EXHEADER)"; for i in $$headerlist; \
+	do  \
+	(cp $$i $(INSTALL_PREFIX)$(INSTALLTOP)/include/openssl/$$i; \
+	chmod 644 $(INSTALL_PREFIX)$(INSTALLTOP)/include/openssl/$$i ); \
+	done;
+
+tags:
+	ctags $(SRC)
+
+tests:
+
+lint:
+	lint -DLINT $(INCLUDES) $(SRC)>fluff
+
+depend:
+	@[ -n "$(MAKEDEPEND)" ] # should be set by upper Makefile...
+	$(MAKEDEPEND) -- $(CFLAG) $(INCLUDES) $(DEPFLAG) -- $(PROGS) $(LIBSRC)
+
+dclean:
+	$(PERL) -pe 'if (/^# DO NOT DELETE THIS LINE/) {print; exit(0);}' $(MAKEFILE) >Makefile.new
+	mv -f Makefile.new $(MAKEFILE)
+
+clean:
+	rm -f *.o */*.o *.obj lib tags core .pure .nfs* *.old *.bak fluff
+
+# DO NOT DELETE THIS LINE -- make depend depends on it.
+
+rlwekex_err.o: ../../include/openssl/bio.h ../../include/openssl/bn.h
+rlwekex_err.o: ../../include/openssl/crypto.h ../../include/openssl/e_os2.h
+rlwekex_err.o: ../../include/openssl/err.h ../../include/openssl/lhash.h
+rlwekex_err.o: ../../include/openssl/opensslconf.h
+rlwekex_err.o: ../../include/openssl/opensslv.h
+rlwekex_err.o: ../../include/openssl/ossl_typ.h ../../include/openssl/rlwekex.h
+rlwekex_err.o: ../../include/openssl/safestack.h ../../include/openssl/stack.h
+rlwekex_err.o: ../../include/openssl/symhacks.h rlwekex_err.c
+rlwekex_key.o: ../../include/openssl/bio.h ../../include/openssl/bn.h
+rlwekex_key.o: ../../include/openssl/crypto.h ../../include/openssl/e_os2.h
+rlwekex_key.o: ../../include/openssl/err.h ../../include/openssl/lhash.h
+rlwekex_key.o: ../../include/openssl/opensslconf.h
+rlwekex_key.o: ../../include/openssl/opensslv.h
+rlwekex_key.o: ../../include/openssl/ossl_typ.h ../../include/openssl/rand.h
+rlwekex_key.o: ../../include/openssl/rlwekex.h
+rlwekex_key.o: ../../include/openssl/safestack.h ../../include/openssl/stack.h
+rlwekex_key.o: ../../include/openssl/symhacks.h rlwekexlib/fft.h rlwekexlib/fft.c 
+rlwekex_key.o: rlwekexlib/rlwe.h rlwekexlib/rlwe.c rlwekexlib/rlwe_a.h
+rlwekex_key.o: rlwekexlib/rlwe_table.h rlwekex_key.c rlwekex_locl.h
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekex.h openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekex.h
--- openssl-1.0.1f/crypto/rlwekex/rlwekex.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekex.h	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,101 @@
+/* crypto/rlwekex/rlwekex.h */
+#ifndef HEADER_RLWEKEX_H
+#define HEADER_RLWEKEX_H
+
+#include <openssl/opensslconf.h>
+
+#ifdef OPENSSL_NO_RLWEKEX
+#error RLWEKEX is disabled.
+#endif
+
+#include <openssl/ossl_typ.h>
+#include <openssl/bn.h>
+#include <openssl/err.h>
+
+#include <stdint.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct rlwe_param_st RLWE_PARAM;
+typedef struct rlwe_pub_st RLWE_PUB;
+typedef struct rlwe_pair_st RLWE_PAIR;
+typedef struct rlwe_rec_st RLWE_REC;
+typedef struct rlwe_ctx_st RLWE_CTX;
+
+/* Allocate and deallocate parameters, public keys, private key / public key pairs, and reconciliation data structures */
+RLWE_PARAM *RLWE_PARAM_new(void);
+void RLWE_PARAM_free(RLWE_PARAM *param);
+
+RLWE_PUB *RLWE_PUB_new(void);
+RLWE_PUB *RLWE_PUB_copy(RLWE_PUB *dest, const RLWE_PUB *src);
+void RLWE_PUB_free(RLWE_PUB *pub);
+
+RLWE_PAIR *RLWE_PAIR_new(void);
+RLWE_PAIR *RLWE_PAIR_copy(RLWE_PAIR *dest, const RLWE_PAIR *src);
+RLWE_PAIR *RLWE_PAIR_dup(const RLWE_PAIR *pair);
+void RLWE_PAIR_free(RLWE_PAIR *pair);
+
+RLWE_REC *RLWE_REC_new(void);
+void RLWE_REC_free(RLWE_REC *rec);
+
+RLWE_CTX *RLWE_CTX_new(void);
+void RLWE_CTX_free(RLWE_CTX *ctx);
+
+/* Generate key pair */
+int RLWE_PAIR_generate_key(RLWE_PAIR *key, RLWE_CTX *ctx);
+
+/* Convert public keys and reconciliation data structures from/to binary */
+RLWE_PUB *o2i_RLWE_PUB(RLWE_PUB **pub, const unsigned char *in, long len);
+int i2o_RLWE_PUB(RLWE_PUB *pub, unsigned char **out);
+RLWE_REC *o2i_RLWE_REC(RLWE_REC **rec, const unsigned char *in, long len);
+int i2o_RLWE_REC(RLWE_REC *rec, unsigned char **out);
+
+/* Get public key from a key pair */
+RLWE_PUB *RLWE_PAIR_get_publickey(RLWE_PAIR *pair);
+/* Does private key exist? */
+int RLWE_PAIR_has_privatekey(RLWE_PAIR *pair);
+
+/* Compute shared secret values */
+int RLWEKEX_compute_key_alice(void *out, size_t outlen, const RLWE_PUB *peer_pub_key,  const RLWE_REC *peer_reconciliation,
+                              const RLWE_PAIR *priv_pub_key, void *(*KDF)(const void *in, size_t inlen, void *out, size_t *outlen), RLWE_CTX *ctx);
+int RLWEKEX_compute_key_bob(void *out, size_t outlen, RLWE_REC *reconciliation, const RLWE_PUB *peer_pub_key,  const RLWE_PAIR *priv_pub_key,
+                            void *(*KDF)(const void *in, size_t inlen, void *out, size_t *outlen), RLWE_CTX *ctx);
+
+/* BEGIN ERROR CODES */
+/* The following lines are auto generated by the script mkerr.pl. Any changes
+ * made after this point may be overwritten when the script is next run.
+ */
+void ERR_load_RLWEKEX_strings(void);
+
+/* Error codes for the RLWEKEX functions. */
+
+/* Function codes. */
+#define RLWEKEX_F_I2O_RLWE_PUB				 100
+#define RLWEKEX_F_I2O_RLWE_REC				 104
+#define RLWEKEX_F_O2I_RLWE_PUB				 101
+#define RLWEKEX_F_O2I_RLWE_REC				 105
+#define RLWEKEX_F_RANDOM32				 111
+#define RLWEKEX_F_RANDOM64				 112
+#define RLWEKEX_F_RANDOM8				 110
+#define RLWEKEX_F_RLWEKEX_				 107
+#define RLWEKEX_F_RLWEKEX_COMPUTE_KEY_ALICE		 108
+#define RLWEKEX_F_RLWEKEX_COMPUTE_KEY_BOB		 109
+#define RLWEKEX_F_RLWE_CTX_NEW				 114
+#define RLWEKEX_F_RLWE_PAIR_COPY			 115
+#define RLWEKEX_F_RLWE_PAIR_NEW				 102
+#define RLWEKEX_F_RLWE_PARAM_NEW			 113
+#define RLWEKEX_F_RLWE_PUB_COPY				 116
+#define RLWEKEX_F_RLWE_PUB_NEW				 103
+#define RLWEKEX_F_RLWE_REC_NEW				 106
+
+/* Reason codes. */
+#define RLWEKEX_R_INVALID_LENGTH			 102
+#define RLWEKEX_R_KDF_FAILED				 100
+#define RLWEKEX_R_RANDOM_FAILED				 101
+
+#ifdef  __cplusplus
+}
+#endif
+#endif
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekex_err.c openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekex_err.c
--- openssl-1.0.1f/crypto/rlwekex/rlwekex_err.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekex_err.c	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,113 @@
+/* crypto/rlwekex/rlwekex_err.c */
+/* ====================================================================
+ * Copyright (c) 1999-2011 The OpenSSL Project.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer. 
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. All advertising materials mentioning features or use of this
+ *    software must display the following acknowledgment:
+ *    "This product includes software developed by the OpenSSL Project
+ *    for use in the OpenSSL Toolkit. (http://www.OpenSSL.org/)"
+ *
+ * 4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For written permission, please contact
+ *    openssl-core@OpenSSL.org.
+ *
+ * 5. Products derived from this software may not be called "OpenSSL"
+ *    nor may "OpenSSL" appear in their names without prior written
+ *    permission of the OpenSSL Project.
+ *
+ * 6. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by the OpenSSL Project
+ *    for use in the OpenSSL Toolkit (http://www.OpenSSL.org/)"
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
+ * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE OpenSSL PROJECT OR
+ * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
+ * OF THE POSSIBILITY OF SUCH DAMAGE.
+ * ====================================================================
+ *
+ * This product includes cryptographic software written by Eric Young
+ * (eay@cryptsoft.com).  This product includes software written by Tim
+ * Hudson (tjh@cryptsoft.com).
+ *
+ */
+
+/* NOTE: this file was auto generated by the mkerr.pl script: any changes
+ * made to it will be overwritten when the script next updates this file,
+ * only reason strings will be preserved.
+ */
+
+#include <stdio.h>
+#include <openssl/err.h>
+#include <openssl/rlwekex.h>
+
+/* BEGIN ERROR CODES */
+#ifndef OPENSSL_NO_ERR
+
+#define ERR_FUNC(func) ERR_PACK(ERR_LIB_RLWEKEX,func,0)
+#define ERR_REASON(reason) ERR_PACK(ERR_LIB_RLWEKEX,0,reason)
+
+static ERR_STRING_DATA RLWEKEX_str_functs[]=
+	{
+{ERR_FUNC(RLWEKEX_F_I2O_RLWE_PUB),	"i2o_RLWE_PUB"},
+{ERR_FUNC(RLWEKEX_F_I2O_RLWE_REC),	"i2o_RLWE_REC"},
+{ERR_FUNC(RLWEKEX_F_O2I_RLWE_PUB),	"o2i_RLWE_PUB"},
+{ERR_FUNC(RLWEKEX_F_O2I_RLWE_REC),	"o2i_RLWE_REC"},
+{ERR_FUNC(RLWEKEX_F_RANDOM32),	"RANDOM32"},
+{ERR_FUNC(RLWEKEX_F_RANDOM64),	"RANDOM64"},
+{ERR_FUNC(RLWEKEX_F_RANDOM8),	"RANDOM8"},
+{ERR_FUNC(RLWEKEX_F_RLWEKEX_),	"RLWEKEX_"},
+{ERR_FUNC(RLWEKEX_F_RLWEKEX_COMPUTE_KEY_ALICE),	"RLWEKEX_compute_key_alice"},
+{ERR_FUNC(RLWEKEX_F_RLWEKEX_COMPUTE_KEY_BOB),	"RLWEKEX_compute_key_bob"},
+{ERR_FUNC(RLWEKEX_F_RLWE_CTX_NEW),	"RLWE_CTX_new"},
+{ERR_FUNC(RLWEKEX_F_RLWE_PAIR_COPY),	"RLWE_PAIR_copy"},
+{ERR_FUNC(RLWEKEX_F_RLWE_PAIR_NEW),	"RLWE_PAIR_new"},
+{ERR_FUNC(RLWEKEX_F_RLWE_PARAM_NEW),	"RLWE_PARAM_new"},
+{ERR_FUNC(RLWEKEX_F_RLWE_PUB_COPY),	"RLWE_PUB_copy"},
+{ERR_FUNC(RLWEKEX_F_RLWE_PUB_NEW),	"RLWE_PUB_new"},
+{ERR_FUNC(RLWEKEX_F_RLWE_REC_NEW),	"RLWE_REC_new"},
+{0,NULL}
+	};
+
+static ERR_STRING_DATA RLWEKEX_str_reasons[]=
+	{
+{ERR_REASON(RLWEKEX_R_INVALID_LENGTH)    ,"invalid length"},
+{ERR_REASON(RLWEKEX_R_KDF_FAILED)        ,"kdf failed"},
+{ERR_REASON(RLWEKEX_R_RANDOM_FAILED)     ,"random failed"},
+{0,NULL}
+	};
+
+#endif
+
+void ERR_load_RLWEKEX_strings(void)
+	{
+#ifndef OPENSSL_NO_ERR
+
+	if (ERR_func_error_string(RLWEKEX_str_functs[0].error) == NULL)
+		{
+		ERR_load_strings(0,RLWEKEX_str_functs);
+		ERR_load_strings(0,RLWEKEX_str_reasons);
+		}
+#endif
+	}
